package com.denizenscript.clientizen.tags;

import com.denizenscript.clientizen.objects.EntityTag;
import com.denizenscript.clientizen.objects.LocationTag;
import com.denizenscript.clientizen.objects.MaterialTag;
import com.denizenscript.denizencore.DenizenCore;
import com.denizenscript.denizencore.objects.ObjectTag;
import com.denizenscript.denizencore.objects.core.ElementTag;
import com.denizenscript.denizencore.objects.core.ListTag;
import com.denizenscript.denizencore.objects.core.MapTag;
import com.denizenscript.denizencore.objects.core.TimeTag;
import com.denizenscript.denizencore.scripts.commands.core.AdjustCommand;
import com.denizenscript.denizencore.tags.PseudoObjectTagBase;
import com.denizenscript.denizencore.tags.TagManager;
import net.minecraft.class_1297;
import net.minecraft.class_310;
import net.minecraft.class_3965;

public class ClientTagBase extends PseudoObjectTagBase<ClientTagBase> {

    public static ClientTagBase instance;

    public ClientTagBase() {
        instance = this;
        TagManager.registerStaticTagBaseHandler(ClientTagBase.class, "client", t -> instance);
        AdjustCommand.specialAdjustables.put("client", mechanism -> tagProcessor.processMechanism(instance, mechanism));
    }

    @Override
    public void register() {
        tagProcessor.registerTag(ListTag.class, "loaded_entities", (attribute, object) -> {
            ListTag entities = new ListTag();
            for (class_1297 entity : class_310.method_1551().field_1687.method_18112()) {
                entities.addObject(new EntityTag(entity));
            }
            return entities;
        });
        tagProcessor.registerTag(EntityTag.class, "target", (attribute, object) -> {
            class_1297 target = class_310.method_1551().field_1692;
            return target != null ? new EntityTag(target) : null;
        });
        tagProcessor.registerTag(LocationTag.class, "cursor_on", (attribute, object) -> {
            return class_310.method_1551().field_1765 instanceof class_3965 blockHit ? new LocationTag(blockHit.method_17777()) : null;
        });
        tagProcessor.registerTag(LocationTag.class, "cursor_on_precise", (attribute, object) -> {
            return class_310.method_1551().field_1765 instanceof class_3965 blockHit ? new LocationTag(blockHit.method_17784()) : null;
        });
        tagProcessor.registerTag(EntityTag.class, "self_entity", (attribute, object) -> {
            return new EntityTag(class_310.method_1551().field_1724);
        });
        tagProcessor.registerTag(ElementTag.class, ElementTag.class, "has_flag", (attribute, object, param) -> {
            return new ElementTag(DenizenCore.serverFlagMap.hasFlag(param.asString()));
        });
        tagProcessor.registerTag(ObjectTag.class, ElementTag.class, "flag", (attribute, object, param) -> {
            return DenizenCore.serverFlagMap.doFlagTag(attribute);
        });
        tagProcessor.registerTag(TimeTag.class, ElementTag.class, "flag_expiration", (attribute, object, param) -> {
            return DenizenCore.serverFlagMap.doFlagExpirationTag(attribute);
        });
        tagProcessor.registerTag(ListTag.class, "list_flags", (attribute, object) -> {
            return DenizenCore.serverFlagMap.doListFlagsTag(attribute);
        });
        tagProcessor.registerTag(MapTag.class, "flag_map", (attribute, object) -> {
            return DenizenCore.serverFlagMap.doFlagMapTag(attribute);
        });
        // TODO this is temporary and is meant for testing only, should be replaced by a proper modifyblock command
        tagProcessor.registerMechanism("modifyblock", false, MaterialTag.class, (object, mechanism, input) -> {
            class_310 client = class_310.method_1551();
            if (client.field_1765 instanceof class_3965 blockHitResult) {
                client.field_1687.method_8501(blockHitResult.method_17777(), input.state);
            }
        });
    }
}
